import re;

fusion_tech = """		<TechInfo>
			<Type>TECH_FUSION</Type>
			<Description>TXT_KEY_TECH_FUSION</Description>
			<Civilopedia>TXT_KEY_TECH_FUSION_PEDIA</Civilopedia>
			<Help/>
			<Strategy>TXT_KEY_TECH_FUSION_STRATEGY</Strategy>
			<Advisor>ADVISOR_SCIENCE</Advisor>
			<iAIWeight>0</iAIWeight>
			<iAITradeModifier>10</iAITradeModifier>
			<iCost>8000</iCost>
			<Era>ERA_MODERN</Era>
			<FirstFreeUnitClass>UNITCLASS_ENGINEER</FirstFreeUnitClass>
			<iFeatureProductionModifier>0</iFeatureProductionModifier>
			<iWorkerSpeedModifier>0</iWorkerSpeedModifier>
			<iTradeRoutes>0</iTradeRoutes>
			<iHealth>0</iHealth>
			<iHappiness>0</iHappiness>
			<iFirstFreeTechs>0</iFirstFreeTechs>
			<iAsset>48</iAsset>
			<iPower>0</iPower>
			<bRepeat>0</bRepeat>
			<bTrade>1</bTrade>
			<bDisable>0</bDisable>
			<bGoodyTech>0</bGoodyTech>
			<bExtraWaterSeeFrom>0</bExtraWaterSeeFrom>
			<bMapCentering>0</bMapCentering>
			<bMapVisible>0</bMapVisible>
			<bMapTrading>0</bMapTrading>
			<bTechTrading>0</bTechTrading>
			<bGoldTrading>0</bGoldTrading>
			<bOpenBordersTrading>0</bOpenBordersTrading>
			<bDefensivePactTrading>0</bDefensivePactTrading>
			<bPermanentAllianceTrading>0</bPermanentAllianceTrading>
			<bVassalTrading>0</bVassalTrading>
			<bBridgeBuilding>0</bBridgeBuilding>
			<bIrrigation>0</bIrrigation>
			<bIgnoreIrrigation>0</bIgnoreIrrigation>
			<bWaterWork>0</bWaterWork>
			<iGridX>19</iGridX>
			<iGridY>5</iGridY>
			<DomainExtraMoves/>
			<CommerceFlexible/>
			<TerrainTrades/>
			<Flavors>
				<Flavor>
					<FlavorType>FLAVOR_PRODUCTION</FlavorType>
					<iFlavor>3</iFlavor>
				</Flavor>
				<Flavor>
					<FlavorType>FLAVOR_SCIENCE</FlavorType>
					<iFlavor>8</iFlavor>
				</Flavor>
			</Flavors>
			<OrPreReqs>
				<PrereqTech>TECH_FIBER_OPTICS</PrereqTech>
			</OrPreReqs>
			<AndPreReqs>
				<PrereqTech>TECH_FISSION</PrereqTech>
			</AndPreReqs>
			<Quote>TXT_KEY_TECH_FUSION_QUOTE</Quote>
			<Sound>AS2D_TECH_FUSION</Sound>
			<SoundMP>AS2D_TECH_MP_FUSION</SoundMP>
			<Button>,Art/Interface/Buttons/TechTree/Fusion.dds,Art/Interface/Buttons/TechTree_Atlas.dds,1,4</Button>
		</TechInfo>
"""
def do_nothing( data ):
    return data

class theory_formatter:
    def __init__(self):
        self.str = ""

    def get_text(self):
        return self.str

    def prt(self, add):
        self.str = "%s%s"%(self.str, add)
        
    def print_entry( self, key, value, extra=0 ):
        for i in range(0, extra, 1):
            self.prt("	")
        self.prt("			<%s>%s</%s>\n"%(key, value, key))

    def print_tag( self, key, extra=0 ):
        for i in range(0, extra, 1):
            self.prt("	")
        self.prt("			<%s>\n"%(key))

    def dump_entry( self, key, some_keys, extra=0, func = do_nothing ):
        if key in some_keys:
            if some_keys[key] is list:
                for content in some_keys[key]:
                    self.print_entry( key, func(content), extra )
            else:
                self.print_entry( key, func(some_keys[key]), extra )
        else:
            for i in range(1, extra, 1):
                self.prt("	")
            self.prt("			<%s/>\n"%key)

    def mult_entry( self, key, some_keys, factor, extra=0  ):
        def mult(data):
            return "%d"%(int(data)*factor)

        self.dump_entry( key, some_keys, extra, mult )
        
    def half_entry( self, key, some_keys, extra=0 ):
        self.mult_entry( key, some_keys, 0.5, extra )

    def double_entry( self, key, some_keys, extra=0 ):
        self.mult_entry( key, some_keys, 2, extra )

    def build_theory( self, some_keys, ratio, PreAndDict, PreOrDict ):
        self.prt("		<TechInfo>\n")
        self.print_entry( 'Type', "%s%s"%(some_keys['Type'], '_THEORY') )
        self.dump_entry( 'Description', some_keys )
        self.dump_entry( 'Civilopedia', some_keys )
        self.dump_entry( 'Help', some_keys )
        self.dump_entry( 'Strategy', some_keys )
        self.dump_entry( 'Advisor', some_keys )
        self.dump_entry( 'iAIWeight', some_keys )
        self.dump_entry( 'iAITradeModifier', some_keys )
        self.mult_entry( 'iCost', some_keys, ratio )
        self.dump_entry( 'Era', some_keys )
        
        self.prt("""			<FirstFreeUnitClass>NONE</FirstFreeUnitClass> 
			<iFeatureProductionModifier>0</iFeatureProductionModifier> 
			<iWorkerSpeedModifier>0</iWorkerSpeedModifier> 
			<iTradeRoutes>0</iTradeRoutes> 
			<iHealth>0</iHealth> 
			<iHappiness>0</iHappiness> 
			<iFirstFreeTechs>0</iFirstFreeTechs>
""")

        self.half_entry( 'iAsset', some_keys )
        self.half_entry( 'iPower', some_keys )

        self.prt("""			<bRepeat>0</bRepeat> 
			<bTrade>1</bTrade> 
			<bDisable>0</bDisable>
""")
        self.dump_entry( 'bGoodyTech', some_keys )
	self.prt("""			<bExtraWaterSeeFrom>0</bExtraWaterSeeFrom> 
			<bMapCentering>0</bMapCentering> 
			<bMapVisible>0</bMapVisible> 
			<bMapTrading>0</bMapTrading> 
			<bTechTrading>0</bTechTrading> 
			<bGoldTrading>0</bGoldTrading> 
			<bOpenBordersTrading>0</bOpenBordersTrading> 
			<bDefensivePactTrading>0</bDefensivePactTrading> 
			<bPermanentAllianceTrading>0</bPermanentAllianceTrading> 
			<bVassalTrading>0</bVassalTrading> 
			<bBridgeBuilding>0</bBridgeBuilding> 
			<bIrrigation>0</bIrrigation> 
			<bIgnoreIrrigation>0</bIgnoreIrrigation> 
			<bWaterWork>0</bWaterWork>
""")

        self.double_entry( 'iGridX', some_keys )
        self.dump_entry( 'iGridY', some_keys )

        self.prt("""			<DomainExtraMoves/>
			<CommerceFlexible/>
			<TerrainTrades/>
""")

        if 'FlavorType' in some_keys:
            self.print_tag('Flavors')
            if isinstance(some_keys['FlavorType'], (list, tuple)):
                flavor_count = len(some_keys['FlavorType'])
                for i in range(0, flavor_count, 1):
                    self.print_tag('Flavor', 1)
                    self.print_entry( 'FlavorType', some_keys['FlavorType'][i], 2 )
                    self.print_entry( 'iFlavor', some_keys['iFlavor'][i], 2 )
                    self.print_tag('/Flavor', 1)
            else:
                self.print_tag('Flavor', 1)
                self.dump_entry( 'FlavorType', some_keys, 2 )
                self.dump_entry( 'iFlavor', some_keys, 2 )
                self.print_tag('/Flavor', 1)
            self.print_tag('/Flavors')
        else:
            self.print_tag('Flavors/')
        
        if len(PreOrDict)>0:
            self.print_tag('OrPreReqs')
            OrTechs = PreOrDict['PrereqTech']
            if isinstance(OrTechs, (list, tuple)):
                for i in OrTechs:
                    self.print_entry('PrereqTech', i, 1)
            else:
                self.dump_entry('PrereqTech', PreOrDict, 1)
            self.print_tag('/OrPreReqs')
        else:
            self.print_tag('OrPreReqs/')

        if len(PreAndDict) > 0:
            self.print_tag('AndPreReqs')
            AndTechs = PreAndDict['PrereqTech']
            if isinstance(AndTechs, (list, tuple)):
                for i in AndTechs:
                    self.print_entry('PrereqTech', i, 1)
            else:
                self.dump_entry('PrereqTech', PreAndDict, 1)
            self.print_tag('/AndPreReqs')
        else:
            self.print_tag('AndPreReqs/')

        self.dump_entry( 'Quote', some_keys )
        self.dump_entry( 'Sound', some_keys )
        self.dump_entry( 'SoundMP', some_keys )
        self.dump_entry( 'Button', some_keys )
        self.prt("		</TechInfo>\n")

def add_tag(some_keys, tag, contents):
    if tag in some_keys:
        if isinstance(some_keys[tag], (list, tuple)):
            some_keys[tag].append(contents)
        else:
            some_keys[tag] = [some_keys[tag], contents]
    else:
        some_keys[tag]=contents

def parse_tech( tech ):
    some_keys = {}

    generic_pattern = re.compile("<(?P<Tag>[^/]*)>([^<\n]*)((<\/(?P=Tag)>)|$)", re.MULTILINE)

    last_match = 0
    InPreOr = 0
    InPreAnd = 0
    PreOrDict = {}
    PreAndDict = {}
    for generic_match in generic_pattern.finditer(tech):
        if generic_match is None:
            print "ERROR: generic pattern failed"
        else:
            skiptag = 0
            start_match = generic_match.start()
            between = tech[last_match:start_match]
            last_match = generic_match.end()
            tag = generic_match.group(1)
            contents = generic_match.group(2)
            closer = generic_match.group(3)

            add_tag( some_keys, tag, contents )
            
            PreOr = PreAnd = 0
            
            if tag=='OrPreReqs':
                PreOr = 1
            else:
                PreOr = 0
                
            if tag=='AndPreReqs':
                PreAnd = 1
            else:
                PreAnd = 0

            if PreOr == 1:
                InPreOr = 1
                InPreAnd = 0
            elif PreAnd == 1:
                InPreOr = 0
                InPreAnd = 1

            if tag == 'PrereqTech' and InPreOr:
                add_tag(PreOrDict, tag, contents)
                skiptag = 1
            elif tag == 'PrereqTech' and InPreAnd:
                add_tag(PreAndDict, tag, contents)
                skiptag = 1
            elif tag == 'PrereqTech':
                print "ERROR ERROR ERROR"
                print "Prereq tech found not in a PreAnd or PreOr!"

    return (some_keys, PreAndDict, PreOrDict)                

def application( tech, ratio = 0.5 ):
    output = ""
    
    some_keys = {}

    generic_pattern = re.compile("<(?P<Tag>[^/]*)>([^<\n]*)((<\/(?P=Tag)>)|$)", re.MULTILINE)
    
    last_match = 0
    InPreOr = 0
    InPreAnd = 0
    for generic_match in generic_pattern.finditer(tech):
        if generic_match is None:
            print "generic pattern failed"
        else:
            skiptag = 0
            start_match = generic_match.start()
            between = tech[last_match:start_match]
            last_match = generic_match.end()
            tag = generic_match.group(1)
            contents = generic_match.group(2)
            closer = generic_match.group(3)
            orig_contents = contents

            add_tag( some_keys, tag, contents )

##            print "(%s) contains (%s) and ends in (%s)"%(tag, contents, closer)
            
            if tag == 'iCost':
                contents = "%d"%(int(contents) * (1-ratio))
            if tag == 'bTrade':
                contents = '0'
            if tag == 'iGridX':
                contents = "%d"%(int(contents) * 2 + 1)
            if tag in ['iAsset', 'iPower']:
                contents = "%d"%(int(contents) / 2)

            PreOr = PreAnd = 0
            
            if tag=='OrPreReqs':
                PreOr = 1
            else:
                PreOr = 0
                
            if tag=='AndPreReqs':
                PreAnd = 1
            else:
                PreAnd = 0

            if PreOr == 1:
                InPreOr = 1
                InPreAnd = 0
            elif PreAnd == 1:
                InPreOr = 0
                InPreAnd = 1
                
            if tag == 'PrereqTech' and InPreOr:
                skiptag = 1
            elif tag == 'PrereqTech' and InPreAnd:
                skiptag = 1
            elif tag == 'PrereqTech':
                print "ERROR ERROR ERROR"
                print "Prereq tech found not in a PreAnd or PreOr!"
                
            output = "%s%s"%(output,between)
            if not skiptag:
                output = "%s%s"%(output,"<%s>%s%s"%(tag, contents, closer))
                
            if PreOr==1:
                theory_name = "%s%s"%(some_keys['Type'], '_THEORY')
                or_tag = 'PrereqTech'
                output = "%s%s"%(output,"<%s>%s</%s>\n"%(or_tag, theory_name, or_tag))

            if PreAnd==1:
                theory_name = "%s%s"%(some_keys['Type'], '_THEORY')
                and_tag = 'PrereqTech'
                output = "%s%s"%(output,"<%s>%s</%s>\n"%(and_tag, theory_name, and_tag))

    between = tech[last_match:]
    output = "%s%s\n"%(output,between)
    return output

def skipped_tech(tech):
    output = ""
    
    some_keys = {}

    generic_pattern = re.compile("<(?P<Tag>[^/]*)>([^<\n]*)((<\/(?P=Tag)>)|$)", re.MULTILINE)
    
    last_match = 0
    for generic_match in generic_pattern.finditer(tech):
        if generic_match is None:
            print "generic pattern failed"
        else:
            skiptag = 0
            start_match = generic_match.start()
            between = tech[last_match:start_match]
            last_match = generic_match.end()
            tag = generic_match.group(1)
            contents = generic_match.group(2)
            closer = generic_match.group(3)
            orig_contents = contents

            add_tag( some_keys, tag, contents )

##            print "(%s) contains (%s) and ends in (%s)"%(tag, contents, closer)
            
            if tag == 'iGridX':
                contents = "%d"%(int(contents) * 2 + 1)

            output = "%s%s"%(output,between)
            output = "%s%s"%(output,"<%s>%s%s"%(tag, contents, closer))

    between = tech[last_match:]
    output = "%s%s\n"%(output,between)
    return output
    
def theory(tech, ratio = 0.5):
    some_keys = {}
    PreAndDict = {}
    PreOrDict = {}
    (some_keys, PreAndDict, PreOrDict) = parse_tech( tech  )
    theory_builder = theory_formatter()
    theory_builder.build_theory( some_keys, ratio, PreAndDict, PreOrDict )
    return theory_builder.get_text()

def for_each_tech(techs):
    tech_start = "		<TechInfo>"
    tech_end = "		</TechInfo>"
    tech_start_re = re.compile("^%s$"%tech_start, re.MULTILINE )
    tech_end_re = re.compile("^%s$"%tech_end, re.MULTILINE )
    
    for start_match in tech_start_re.finditer(techs):
        tech_start = start_match.start()

        end_match = tech_end_re.search(techs, tech_start)
        if end_match is None:
            print "ERROR: <TechInfo> at %d with no matching </TechInfo>"%tech_start
            return

        tech_end = end_match.end()

        tech_sample = techs[tech_start:tech_end]
        yield tech_sample


def print_both(tech, ratio, skip):
    (some_keys, PreAndDict, PreOrDict) = parse_tech( tech  )
    if some_keys['Type'] in skip:
        skipped = skipped_tech(tech)
        print skipped,
    else:
        theo = theory(tech)
        app = application(tech)
        print theo,
        print app,

def munge(line):
    empty_tag = re.compile("^(?P<Tabs>	*)<(?P<Tag>.*)\/>$")
    empty_match = empty_tag.search(line)
    if empty_match is None:
        return line
    else:
        tabs = empty_match.group(1)
        tag = empty_match.group(2)
        line1 = "%s<%s>\n"%(tabs, tag)
        line2 = "%s</%s>\n"%(tabs, tag)
        result = "%s%s"%(line1, line2)
        return result
    
import fileinput
all_techs = []
for line in fileinput.input():
    all_techs.append(munge(line))

all_techs="".join(all_techs)
print """<?xml version="1.0"?>
<!-- edited with XMLSpy v2005 rel. 3 U (http://www.altova.com) by Soren Johnson (Firaxis Games) -->
<!-- edited with XMLSPY v2004 rel. 2 U (http://www.xmlspy.com) by Alex Mantzaris (Firaxis Games) -->
<!-- Sid Meier's Civilization 4 -->
<!-- Copyright Firaxis Games 2005 -->
<!-- -->
<!-- Tech Infos -->
<Civ4TechInfos xmlns="x-schema:CIV4TechnologiesSchema.xml">
	<TechInfos>
""",

skip_techs = [
    'TECH_MYSTICISM',
    'TECH_FISHING',
    'TECH_MINING',
    'TECH_THE_WHEEL',
    'TECH_AGRICULTURE',
    'TECH_POTTERY',
    'TECH_SAILING',
    'TECH_HUNTING',
    'TECH_ARCHERY',
    'TECH_MASONRY',
    'TECH_ANIMAL_HUSBANDRY',
    'TECH_FUTURE_TECH'
]

for tech in for_each_tech(all_techs):
    print_both(tech, 0.5, skip_techs)

print """	</TechInfos>
</Civ4TechInfos>
""",
